#Alice und Bob werfen mehrmals hintereinander eine faire Münze mit der Aufschrift 0 und 1.
#Alicee zählt ihre Würfe. Auch Bob zählt seine Würfe.
#Wenn bei Alice eine 1 auf eine 0 folgt oder bei Bob eine 0 auf eine 0, ist das Spiel beendet.
#Wie oft muss die Münze im Mittel geworfen werden, damit einer von beiden gewinnt?
import random
import time
t0 = time.time()                     # Startzeit
muenze=[0,1]                         # Definition der Münze
n=50                                 #Anzahl der Simulationen einer Serie
s00=0                                #Summation für 00
s01=0                                #Summation für 01
min0=0                               #letzte Element der umgestellten Liste für 00
min1=0                               #vorletzte Element der umgestellten Liste für 00
min3=0                               #letzte Element der umgestellten Liste für 01
min4=0                               #vorletzte Element der umgestellten Liste für 01
stelle00=0                           #sucht die Stellen mit Nullen
liste=[]                             #leere Liste
k=5000                               #Anzahl der Serien
z00=0                                #Anzahl der Duchläufe für 
for i in range(k):
    random.seed()                    #Zufallszahlengenerator neu starten
    for i in range(n):               #Schleife mit n Simulationen einer Serie
        x = random.choice(muenze)    # wähle zufällig aus muenze eine Zahl
        liste.append(x)              #fügt die Zufallszahl in die Liste ein
        stelle00 = list(i for i in range(len(liste)) if liste[i] == 0)
    um00=stelle00[::-1]              #kehrt die Liste um
    um2=um00[:]                      #kopiert die Liste
    while um00 != []:                #Anzahl der Würfe für 00 wird gesucht, wiederhole so lange bis Liste nicht leer ist
        min0=um00.pop()              #nimmt den letzten Wert aus der Liste und merkt ihn sich
        min1=um00.pop()              #nimmt den letzten Wert aus der um 1 Element verkleinerten Liste und merkt ihn sich
        if min0+1<min1:              #überprüft, ob 00 aufeinader folgen
           um00.append(min1)         #fügt das letzte Element wieder in die Liste ein, da Mißerfolg von 00
        else:
           break                     #Erfolg, if Schleife beenden
           continue
    liste=[]                         #Liste wird geleert für einen neuen Durchlauf
    s00=(s00+min1+1)                 #Anzahl der Würfe für 00 werden aufsummiert
    z00=z00+1                        #Anzahl der Durchläufe
    while um2 != []:                 #Anzahl der Würfe für 01 wird gesucht, wiederhole so lange bis Liste nicht leer ist
        min3=um2.pop()               #nimmt den letzten Wert aus der Liste und merkt ihn sich
        min4=um2.pop()               #nimmt den letzten Wert aus der um 1 Element verkleinerten Liste und merkt ihn sich
        if min4-min3>1:              #überprüft, ob nicht 00 aufeinander folgen
           break                     #Erfolg, if Schleife beenden
        else:
           um2.append(min4)          #fügt das letzte Element wieder in die Liste ein, da Erfolg von 00      
    s01=(s01+min3+2)                 #Anzahl der Würfe für 01 werden aufsummiert
print("Alice muss bei ",k," Versuchen im Durchschnitt", round(s01/z00,3),"Mal die Münze werfen, bis 01 kommt.")
print("Bob   muss bei ",k," Versuchen im Durchschnitt", round(s00/z00,3),"Mal die Münze werfen, bis 00 kommt.")
print ("Laufzeit = ", time.time() - t0," sec")
