#Alice und Bob werfen mehrmals hintereinander eine faire Münze mit der Aufschrift 0 und 1.
#Alice zählt ihre Würfe. Auch Bob zählt seine Würfe.
#Wenn bei Alice eine 1 auf eine 0 folgt oder bei Bob eine 0 auf eine 0, ist das Spiel beendet.
#Wie oft müssen die jeweiligen Spieler die Münze im Mittel werfen, damit das Spiel beendet wird?

import random
import time
t0 = time.time() 
k=5000
muenze=[0,1]
anzahlAGewinnt = 0
anzahlBGewinnt = 0
anzahlUnentschieden = 0
anzahlWuerfeGesamt = 0
anzahlWuerfeAGesamt = 0
anzahlWuerfeBGesamt = 0


collection = ['Alice', 'Bob']
for i in range(0,k):
    anzahlWuerfeA = 0
    anzahlWuerfeB = 0
    for spieler in collection:
        anzahlWuerfeProSpiel = 0
        was0 = False
        random.seed()
        while(True):             
            x = random.choice(muenze)
            # print("werfe ", x, " für ", spieler)
            anzahlWuerfeProSpiel += 1
            if(was0):
                if((x==1) & (spieler is 'Alice')):
                    anzahlWuerfeA = anzahlWuerfeProSpiel
                    break
                else:
                    if((x==0) & (spieler is 'Bob')):
                        anzahlWuerfeB = anzahlWuerfeProSpiel
                        break
            was0 = (x == 0)
    if (anzahlWuerfeA == anzahlWuerfeB):
        anzahlUnentschieden += 1
        
    else:
        if (anzahlWuerfeA < anzahlWuerfeB):
            anzahlAGewinnt += 1
        else:
            anzahlBGewinnt +=1
    anzahlWuerfeGesamt += anzahlWuerfeA
    anzahlWuerfeGesamt += anzahlWuerfeB
    anzahlWuerfeAGesamt += anzahlWuerfeA
    anzahlWuerfeBGesamt += anzahlWuerfeB
if (anzahlAGewinnt > anzahlBGewinnt):
    gewinner = "Alice"
else:
        gewinner = "Bob"
print("Im Schnitt hat ", gewinner," die geringere Anzahl von Würfen, bevor ein Spiel beendet wird: ", round(anzahlAGewinnt*100/k,3), "% der Spiele gewinnt Alice vs. ", round(anzahlBGewinnt*100/k,3), "% der Spiele gewinnt Bob")
print("Damit einer von beiden gewinnt, muss die Münze im Mittel ", round(anzahlWuerfeGesamt/(2*k),3)," geworfen werden")
print("Damit Alice gewinnt, muss die Münze im Mittel ", round(anzahlWuerfeAGesamt/(k),3)," geworfen werden")
print("Damit Bob gewinnt, muss die Münze im Mittel ", round(anzahlWuerfeBGesamt/(k),3)," geworfen werden")
print ("Laufzeit = ", time.time() - t0," sec")

